#ifndef  CLIB_XMODULE_PROTOS_H
#define  CLIB_XMODULE_PROTOS_H

/*
**	$VER: xmodule_protos.h 4.0 (16.1.96)
**
**	C prototypes. For use with 32 bit integers only.
**
**	(C) Copyright 1995,96 Bernardo Innocenti
**	    All Rights Reserved
*/

#ifndef  EXEC_TYPES_H
#include <exec/types.h>
#endif
#ifndef  UTILITY_TAGITEM_H
#include <utility/tagitem.h>
#endif
#ifndef  LIBRARIES_XMODULE_H
#include <libraries/xmodule.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

/*--- functions in V1 or higher (Release 4.0) ---*/

/* Public entries */

struct SongInfo *xmCreateSongA( struct TagItem * tagList );
struct SongInfo *xmCreateSong( ULONG tag1, ... );
BOOL xmDeleteSong( struct SongInfo *si );
ULONG xmAddSongA( struct SongInfo *si, struct SongInfo *position, struct TagItem *tagList );
ULONG xmRemSong( struct SongInfo *si );
ULONG xmActivateSong( struct SongInfo *si );
struct SongInfo *xmLockActiveSong( UWORD mode );
struct XMHook *xmAddHookA( struct TagItem * tagList );
struct XMHook *xmAddHook( ULONG tag1, ... );
void xmRemHook ( struct XMHook *hook );
struct XMHook *xmIdentifyModule( BPTR fh, struct TagItem * tagList );
struct SongInfo *xmLoadModuleA( CONST_STRPTR fileName, struct TagItem * tagList );
struct SongInfo *xmLoadModule( CONST_STRPTR fileName, ULONG tag1, ... );
LONG xmSaveModuleA( struct SongInfo *si, CONST_STRPTR filename, struct XMHook *saver, struct TagItem * tagList );
LONG xmSaveModule( struct SongInfo *si, CONST_STRPTR filename, struct XMHook *saver, ULONG tag1, ... );
UWORD *xmSetSongLen( struct SongInfo *si, UWORD length );
struct Pattern *xmAddPatternA( struct SongInfo *, struct TagItem *);
struct Pattern *xmAddPattern( struct SongInfo *, LONG Tag1, ...);
struct Pattern *xmSetPatternA( struct SongInfo *, ULONG pattNum, struct TagItem * );
struct Pattern *xmSetPattern( struct SongInfo *, ULONG pattNum, LONG Tag1, ...);
void xmRemPattern( struct SongInfo *, LONG, LONG );
struct Instrument *xmAddInstrumentA( struct SongInfo *, LONG instrNum, struct TagItem * );
struct Instrument *xmAddInstrument( struct SongInfo *, LONG instrNum, LONG, ... );
struct Instrument *xmSetInstrumentA( struct SongInfo *, LONG instrNum, struct TagItem * );
struct Instrument *xmSetInstrument( struct SongInfo *, LONG instrNum, LONG, ... );
void xmRemInstrument( struct SongInfo *, LONG );
LONG xmProcessSongA( struct SongInfo *, void *, struct TagItem * );
LONG xmProcessSong( struct SongInfo *, void *, LONG, ... );
LONG xmDisplayMessageA( LONG level, APTR messsage, APTR args );
LONG xmDisplayMessage( LONG level, APTR messsage, ... );
LONG xmDisplayProgress( ULONG actual, ULONG total );

#ifdef __cplusplus
}
#endif

#endif	 /* CLIB_XMODULE_PROTOS_H */
