#ifndef LIBRARIES_SONGCLASS_H
#define LIBRARIES_SONGCLASS_H
/*
**	$VER: songclass.h 3.9 (16.1.96)
**	Copyright (C) 1996 Bernardo Innocenti
**
**	Set TAB size to 4 chars to read this header file
**
**	Song class definition.
*/

#ifndef	EXEC_SEMAPHORES_H
#include <exec/semaphores.h>
#endif /* EXEC_SEMAPHORES_H */

#ifndef	INTUITION_CLASSES_H
#include <intuition/classes.h>
#endif /* INTUITION_CLASSES_H */



/* The name of the songclass */
#define SONGCLASS "songclass"



/* Song methods */
#define SNGM_Dummy				(TAG_USER + ('SG'<<8))
#define SNGM_ADDPATTERN			(SNGM_Dummy + 1)
#define SNGM_SETPATTERN			(SNGM_Dummy + 2)
#define SNGM_REMPATTERN			(SNGM_Dummy + 3)
#define SNGM_ADDINSTRUMENT		(SNGM_Dummy + 4)
#define SNGM_SETINSTRUMENT		(SNGM_Dummy + 5)
#define SNGM_REMINSTRUMENT		(SNGM_Dummy + 6)
#define SNGM_SWAPINSTRUMENTS	(SNGM_Dummy + 7)


#define spAddPattern opSet		/* No GadgetInfo field required */

struct spSetPattern
{
	ULONG			 MethodID;
	ULONG			 spsp_PattNum;
	struct TagItem	*spsp_AttrList;
};

struct spRemPattern
{
	ULONG	MethodID;
	ULONG	sprp_PattNum;
	ULONG	sprp_NewPatt;
};

struct spSetInstrument
{
	ULONG			 MethodID;
	ULONG			 spsi_InstrNum;
	struct TagItem	*spsi_AttrList;
};

#define spAddInstrument spSetInstrument

struct spRemInstrument
{
	ULONG			 MethodID;
	ULONG			 spri_Num;
};

struct spSwapInstruments
{
	ULONG			 MethodID;
	ULONG			 spsi_Num1;
	ULONG			 spsi_Num2;
};



/* Song attributes */

#define SNGA_Dummy			(TAG_USER + 'SG'<<8)	/* use	*/

#define SNGA_CurrentPatt	(SNGA_Dummy + 1)		/* ISG	*/
#define SNGA_CurrentPos		(SNGA_Dummy + 2)		/* ISG	*/
#define SNGA_CurrentInst	(SNGA_Dummy + 3)		/* ISG	*/
#define SNGA_CurrentLine	(SNGA_Dummy + 4)		/* ISG	*/
#define SNGA_CurrentTrack	(SNGA_Dummy + 5)		/* ISG	*/

#define SNGA_Length			(SNGA_Dummy + 6)		/* ISG	*/
#define SNGA_NumPatterns	(SNGA_Dummy + 7)		/* G	*/
#define SNGA_NumInstruments	(SNGA_Dummy + 8)		/* G	*/
#define SNGA_MaxTracks		(SNGA_Dummy + 9)		/* G	*/

#define SNGA_Title			(SNGA_Dummy + 10)		/* ISG	*/
#define SNGA_Author			(SNGA_Dummy + 11)		/* ISG	*/
#define SNGA_Description	(SNGA_Dummy + 12)		/* ISG	*/
/* (UBYTE *) Long description/comment for the
 * song. The string may contain newlines and there is no
 * length limit.
 */

#define SNGA_Path			(SNGA_Dummy + 13)		/* ISG	*/
/* The complete path name of the file the song was
 * loaded from.
 */

#define SNGA_Changes		(SNGA_Dummy + 14)		/* ISG	*/
/* (ULONG) Sets the number of changes made to the song
 * since the last time it was saved.
 */

#define SNGA_TotalChanges	(SNGA_Dummy + 15)		/* ISG	*/
/* (ULONG) Total number of changes made to the song
 * since it has been created.
 */

#define SNGA_CreationDate	(SNGA_Dummy + 16)		/* ISG	*/
#define SNGA_LastChanged	(SNGA_Dummy + 17)		/* ISG	*/
/* (ULONG) Datestamp of last time the song was saved
 */

#define SNGA_DefaultTracks	(SNGA_Dummy + 32)		/* ISG	*/
#define SNGA_DefaultPattLen	(SNGA_Dummy + 33)		/* ISG	*/
#define SNGA_GlobalSpeed	(SNGA_Dummy + 34)		/* ISG	*/
#define SNGA_GlobalTempo	(SNGA_Dummy + 35)		/* ISG	*/
#define SNGA_RestartPos		(SNGA_Dummy + 36)		/* ISG	*/

#define SNGA_ReadyToUse		(SNGA_Dummy + 37)		/* I	*/
/* (BOOL) Add one position and one pattern when
 * creating a new song.
 */

#define PATTA_Dummy			(TAG_USER + 'PA'<<8)
#define PATTA_Lines			(PATTA_Dummy + 1)		/* I	*/
#define PATTA_Tracks		(PATTA_Dummy + 2)		/* I	*/
#define PATTA_Name			(PATTA_Dummy + 3)		/* IS	*/
#define	PATTA_Pattern		(PATTA_Dummy + 4)		/* I	*/
#define PATTA_Num			(PATTA_Dummy + 5)		/* I	*/
#define PATTA_Replace		(PATTA_Dummy + 6)		/* I	*/


#define INSTRA_Dummy		(TAG_USER + 'IN'<<8)
#define INSTRA_Type			(INSTRA_Dummy + 1)		/* I	*/
#define INSTRA_Name			(INSTRA_Dummy + 2)		/* IS	*/
#define INSTRA_Volume		(INSTRA_Dummy + 3)		/* IS	*/
#define INSTRA_Sample 		(INSTRA_Dummy + 4)		/* IS	*/
#define INSTRA_Length 		(INSTRA_Dummy + 5)		/* IS	*/
#define INSTRA_Flags		(INSTRA_Dummy + 6)		/* IS	*/
#define INSTRA_LoopStart	(INSTRA_Dummy + 7)		/* IS	*/
#define INSTRA_LoopLen		(INSTRA_Dummy + 8)		/* IS	*/
#define INSTRA_LoopEnd		(INSTRA_Dummy + 9)		/* IS	*/
#define INSTRA_FineTune		(INSTRA_Dummy + 10)		/* IS	*/


/* ProTracker-style aliases for loop tags */
#define INSTRA_Repeat	INSTRA_LoopStart
#define INSTRA_Replen	INSTRA_LoopLen
#define INSTRA_Repend	INSTRA_LoopEnd


/* Default values for some song attributes */
#define DEF_PATTLEN		 64
#define DEF_NUMTRACKS	  4
#define DEF_SONGSPEED	  6
#define DEF_SONGTEMPO	125


/* Maximum values */
#define MAXOCTAVES			6			/* Number of octaves currently supported	*/
#define MAXNOTES	(12*MAXOCTAVES+1)	/* Number of entries in notes table			*/
#define MAXTRACKS		  	255			/* Maximum number of tracks in a pattern	*/
#define MAXINSTRUMENTS		255			/* Maximum number of instruments in a song	*/
#define MAXPATTERNS		  32767			/* Maximum number of patterns				*/
#define MAXPATTLINES	  32767			/* Maximum number of lines in a pattern		*/
#define MAXPOSITIONS	  32767			/* Maximum number of song positions			*/

#define	SEQUENCE_QUANTUM	32		/* Multiples of SEQUENCE_QUANTUM positions are
									 * allocated in the sequence array
									 */
#define	PATTERNS_QUANTUM	16		/* Multiples of PATTERNS_QUANTUM pointers are
									 * allocated in the patterns array
									 */

struct Instrument
{
	UWORD	 Type;				/* Instrument type (See defs)	*/
	UWORD	 Volume;			/* Volume (max $40)				*/
	STRPTR	 Name;				/* Instrument Name				*/
	ULONG	 Length;			/* Length of instr				*/
	BYTE	*Sample;			/* Sampled data					*/
	ULONG	 Repeat;			/* Loop start (No loop = 0)		*/
	ULONG	 Replen;			/* Loop size (No loop = 1)		*/
	WORD	 FineTune;			/* Instrument FineTune (-8..+7)	*/
	UWORD	 Flags;				/* Unused						*/
};


#ifndef LIBRARIES_XMODULECLASS_H

/* Possibile values for Instrument->InstType */
enum {
	ITYPE_SAMPLE8,		/* 8 bit sampled waveform				*/
	ITYPE_SAMPLE16,		/* TODO: 16 bit sampled waveform		*/
	ITYPE_SYNTH,		/* TODO: Synthetic instrument			*/
	ITYPE_HYBRID,		/* TODO: Both Synth & Sample			*/
	ITYPE_MIDI			/* TODO: Played by external MIDI device	*/
};
#endif /* !LIBRARIES_XMODULECLASS_H */



/* Pass this value to AllocVec() to allocate sample memory */
#define MEMF_SAMPLE	MEMF_ANY


#ifndef LIBRARIES_XMODULECLASS_H
struct Note
{
	UBYTE Note;				/* See below for more info.	*/
	UBYTE Inst;				/* Instrument number		*/
	UBYTE Vol;				/* Volume for this note		*/
	UBYTE Pad;				/* Unused					*/
	UBYTE EffNum;			/* See definitions below.	*/
	UBYTE EffVal;			/* Effect value ($00-$FF)	*/
};
#endif /* !LIBRARIES_XMODULECLASS_H */



struct Pattern
{
	UWORD	Tracks;					/* Support for variable number of tracks	*/
	UWORD	Lines;					/* Number of lines in pattern				*/
	STRPTR	Name;					/* Name of this pattern						*/
	ULONG	Reserved[2];			/* Reserved for future enhancements			*/
	struct Note *Notes[0];			/* Pointers to the lines					*/

	/* Note: dynamic size structure!	*/
};



/*
 * Effects
 */
#ifndef LIBRARIES_XMODULECLASS_H
enum {
	EFF_NULL,				/* $00 */
	EFF_PORTAMENTOUP,		/* $01 */
	EFF_PORTAMENTODOWN,		/* $02 */
	EFF_TONEPORTAMENTO,		/* $03 */
	EFF_VIBRATO,			/* $04 */
	EFF_TONEPVOLSLIDE,		/* $05 */
	EFF_VIBRATOVOLSLIDE,	/* $06 */
	EFF_TREMOLO,			/* $07 */
	EFF_UNUSED,				/* $08 */
	EFF_SAMPLEOFFSET,		/* $09 */
	EFF_VOLSLIDE,			/* $0A */
	EFF_POSJUMP,			/* $0B */
	EFF_SETVOLUME,			/* $0C */
	EFF_PATTERNBREAK,		/* $0D */
	EFF_MISC,				/* $0E */
	EFF_SETSPEED,			/* $0F */
	EFF_SETTEMPO,			/* $10 */
	EFF_ARPEGGIO,			/* $11 */

	EFF_COUNT				/* $12 */
};
#endif /* !LIBRARIES_XMODULECLASS_H */



/* Song class white box istance
 *
 * You can read from this structure directly for speed critical operations.
 * Modifying the data contained in the SongInfo structure is only allowed
 * by means of object methods.
 *
 * Before using a public song, please protect yourself against other tasks
 * modifying these fields. Always obtainin a (shared) lock on the
 * SignalSemaphore contained in the SongInfo structure before doing anything
 * with it. The methods provided by the song class will not handle access
 * arbitration for you.
 */
struct SongInfo
{
	struct Node Link;				/* Link for the song list					*/
	struct SignalSemaphore Lock;	/* Prevent other tasks from disturbing you!	*/
	UWORD		Length;				/* Number of positions in song				*/
	UWORD		MaxTracks;			/* Maximum number of tracks in song			*/
	UWORD		NumPatterns;		/* Number of patterns in song				*/
	UWORD		LastInstrument;		/* Unused									*/
	UWORD		CurrentPatt;
	UWORD		CurrentPos;
	UWORD		CurrentInst;
	UWORD		CurrentLine;
	UWORD		CurrentTrack;
	UWORD		DefNumTracks;		/* Default number of tracks in new patterns	*/
	UWORD		DefPattLen;			/* Default number of lines in new patterns	*/
	UWORD		GlobalSpeed;		/* Default song speed						*/
	UWORD		GlobalTempo;		/* Default song tempo						*/
	UWORD		RestartPos;			/* Position to restart from					*/
	UWORD		Reserved[4];		/* Reserved for future enhancements			*/

	/* Note: all data beyond this point is longword aligned */

	ULONG		Flags;				/* See definitions below					*/
	void		*Pool;				/* Memory pool from which all song data
									 * must be allocated from.
									 */
	UWORD				*Sequence;	/* Pointer to song sequence					*/
	struct Pattern		**Patt;		/* Pointer to patterns array				*/
	struct Instrument	**Instr;	/* Pointer to instruments array				*/
	UWORD		*ActiveTracks;		/* (-1 = disabled) *yet unused*				*/
	STRPTR		Title;				/* Song name								*/
	STRPTR		Author;				/* Name of the author						*/
	STRPTR		Path;				/* Original song path						*/
	STRPTR		Description;		/* Verbose song description					*/

	ULONG		Changes;			/* Changes made since song was last saved	*/
	ULONG		TotalChanges;		/* Total number of changes made so far		*/
	ULONG		CreationDate;		/* Date of OM_NEW							*/
	ULONG		LastChanged;		/* Date of last saving						*/


	/* PRIVATE DATA --- HANDS OFF!
	 *
	 * All fields beyond this point are subject to change and
	 * *will* change in future releases of XModule. Do not
	 * even think of using them for whatever reason. Right? :-)
	 */
	struct Instrument *InstrumentsTable[MAXINSTRUMENTS + 1];
};



/* Flags for SongInfo->Flags */
/* No flags are defined yet */



#endif /* !LIBRARIES_SONGCLASS_H */
